
#include "common_functions.hpp"
#include "directed_graph.hpp"
#include "utils_divers.hpp"
#include "types_graph.hpp"


void display_string(string s)
{
	cout << s ;
}


string toString_value(string s)
{
	return s ;
}


graph<string>* create_initial_graph(
							  string graph_name,
							  bool label_noeuds,
							  vector<string>& objects_names,
							  vector<string>& description_noeuds,
							  Tadjacences_map& adjacences,
							  bool graphe_oriente,
							  abstraction& a1,
							  abstraction& a2	
					     	)
{
							// creation des noeuds du graph
	Tvertices_map<string> vertices ;

	for (unsigned int i = 0 ; i < objects_names.size() ; i++)
	{
		Tvertice<string> v ;

		v.value     = objects_names[i] ;
		if (label_noeuds)
			v.label     = description_noeuds[i] ;
		v.component = -1 ;

		vertices.insert(make_pair(i, v)) ;
	}

	graph<string>* g ;

	if (graphe_oriente)
		g = new directed_graph<string>(graph_name, vertices, adjacences,
								 	   display_string, toString_value) ;
	else
          g = new graph<string>(graph_name, vertices, adjacences,
			                    display_string, toString_value) ;

	if (a1.get_abstraction_topologique() > 0 || a2.get_abstraction_topologique() >0)
	    g->compute_map_degres() ;	

	return g ;
}


	// affichage des adjacences
void afficher_adjacences(Tadjacences_map&  adjacences)
{
				  // affichage des adjacences
	for(Tadjacences_map_iterator it = adjacences.begin(); it != adjacences.end(); ++it)
	{
		cout << "rang_objet = " << it->first << endl ;
		displaySet("predecesseurs", it->second.predeccessors) ;
		displaySet("successors", it->second.successors) ;
	}
}

	// partitionne les noeuds en fonction de leurs noms
	// prefixe 'o' => output (VO)
	// prefixe 'i' => input (VI)
void detect_out_in(vector<string>& objects_names,
				   set<Tvertice_identifier>& VO,
				   set<Tvertice_identifier>& VI,
				   map<string, Tvertice_identifier>& vertice_idents)

{
	for (Tvertice_identifier i = 0 ; i < objects_names.size() ; i++)
	{
			if (objects_names[i].at(0) == 'o')
			{
				VO.insert(i) ;
			}
			else
			{
				if (objects_names[i].at(0) == 'i')
				{
					VI.insert(i) ;
				}
				else
					cerr << "!!! erreur : le noeud " << i << "n'est ni output ni input" << endl ;
			}

			// cout << "xxx" << objects_names[i] << "xxx" << endl ;

			vertice_idents.insert(pair<string,Tvertice_identifier>("" + objects_names[i]+"", i)) ;
	}

	// displayMap("vertices", vertice_idents) ;
	// displaySet("VO", VO) ;
	// displaySet("VI", VI) ;

}
