/*
 * type_abstraction.hpp
 *
 *  Created on: 4 mai 2016
 *      Author: dominique
 */

#ifndef _ABSTRACTION_HPP_
#define _ABSTRACTION_HPP_

#include <utility>
using namespace std ;
									// structure pour definir les abstractions
									// appliquées sur un graphe
class abstraction
{
	private :
									// VARIABLES D'INSTANCES
		bool				role ;				// au moins 2 roles
		int             	k_dense ;
		int  				degree  ;
		int					degree_in ;
		int					degree_out ;
		int             	degre_simple ;
		int  				connected_components ;
		bool 				triangles ;
		pair<int, int>  	classic_hub_autority ;
		pair<int, int>  	hub_autority ;
		pair<int, int>  	near_star ;
		pair<int, int>  	near_star_in ;
		pair<int, int>  	near_star_out ;
		float				abstraction_topologique ;


	public :
									// CONSTRUCTEURS
		abstraction() ;
		abstraction(int k_dense, int degree, int degree_in, int degree_out,
				  	int degre_simple, int connected_components,
					bool triangles,  pair<int, int> classic_hub__autority,
					pair<int, int> hub__autority,
					pair<int, int> near_star,
					pair<int, int> near_star_in, pair<int, int> near_star_out,
					float abstraction_topologique, bool role) ;

									// GETTERS
		int get_k_dense() ;
		int get_degree()  ;
		int get_degree_in() ;
		int get_degree_out() ;
		int get_degre_simple() ;
		int get_connected_components() ;
		bool get_triangles() ;
		pair<int, int> get_classic_hub_autority() ;
		pair<int, int> get_hub_autority() ;
		pair<int, int> get_near_star() ;
		pair<int, int> get_near_star_in() ;
		pair<int, int> get_near_star_out() ;
		float get_abstraction_topologique() ;
		bool get_role() ;

									// SETTERS
		void set_k_dense(int v) ;
		void set_degree(int v)  ;
		void set_degree_in(int v) ;
		void set_degree_out(int v) ;
		void set_degre_simple(int v) ;
		void set_connected_components(int v) ;
		void set_triangles(bool v) ;
		void set_classic_hub_autority_first(int v) ;
		void set_classic_hub_autority_second(int v) ;
		void set_hub_autority_first(int v) ;
		void set_hub_autority_second(int v) ;
		void set_near_star_first(int v) ;
		void set_near_star_second(int v) ;
		void set_near_star_in_first(int v) ;
		void set_near_star_in_second(int v) ;
		void set_near_star_out_first(int v) ;
		void set_near_star_out_second(int v) ;
		void set_abstraction_topologique(float v) ; 
		void set_role(bool role) ;
} ;

#endif /* _ABSTRACTION_HPP_ */
