/*
 * types_graph.hpp
 *
 *  Created on: 26 avr. 2016
 *  Author: dominique Bouthinon (LIPN Université Paris13)
 *
 *  Ensemble de types utilisés par la class graph et les class dérivées
 */

#ifndef TYPES_GRAPH_HPP_
#define TYPES_GRAPH_HPP_

#include <string>
#include <map>
#include <set>

using namespace std ;

typedef int Tvertice_identifier ;
typedef int Tcomponent_identifier ;

										// description interne d'un noeud
template<typename Tvalue>
struct Tvertice
{
	Tvalue 				  value     ;		// valeur du noeud
	string 				  label     ;		// label du noeud
	Tcomponent_identifier component ;		// identifiant de la composante connexe du noeud
};


template<typename Tvalue>
using Tvertices_map = map<Tvertice_identifier, Tvertice<Tvalue> > ;

template<typename Tvalue>
using Tvertices_map_iterator = typename map<int, Tvertice<Tvalue> >::iterator ;

								// identifieurs de noeuds
typedef set<Tvertice_identifier> Tvertice_identifiers_set  ;
typedef Tvertice_identifiers_set::iterator Tvertice_identifiers_set_iterator ;

								// adjacences
struct Tadjacences
{
	Tvertice_identifiers_set predeccessors ;
	Tvertice_identifiers_set successors ;
};

typedef map<Tvertice_identifier, Tadjacences> Tadjacences_map ;
typedef Tadjacences_map::iterator Tadjacences_map_iterator ;

								// composantes connexes
typedef map<Tcomponent_identifier, Tvertice_identifiers_set>  Tconnected_components ;
typedef Tconnected_components::iterator Tconnected_components_iterator;

								// communautes
typedef Tvertice_identifiers_set Tvertices_set ;
typedef map<Tvertice_identifier, Tvertices_set> Tvertices_set_map ;
typedef Tvertices_set_map::iterator Tvertices_set_map_iterator ;


#endif /* TYPES_GRAPH_HPP_ */
