/**
 *  GERE CERTAINS PAREMETRES D'ENTREE DES PROGRAMMES
 *  minerLC, supportsAttendus, supportsAttendusLocaux
 *
 */

#include <iostream>
#include <stdio.h>
#include <string>

#include "abstraction.hpp"

using std::cout;
using std::cerr;
using std::endl;


using namespace std;

	// affiche les abstractions demandées dans a
void write_abstractions(abstraction& a, string message)
{
  cout << "# min degree                  " << message << " = " << a.get_degree()  << endl ;
  cout << "# min degee in                " << message << " = " << a.get_degree_in() << endl ;
  cout << "# min degee out               " << message << " = " << a.get_degree_out() << endl ;
  cout << "# min degre_simple            " << message << " = " << a.get_degre_simple() << endl ;
  cout << "# k-dense abstract            " << message << " = " << a.get_k_dense() << endl ;
  cout << "# triangles abstract          " << message << " = " << a.get_triangles() << endl ;
  cout << "# near star degree            " << message << " = " << a.get_near_star().first << endl ;
  cout << "# near star distance          " << message << " = " << a.get_near_star().second << endl ;
  cout << "# near star in degree         " << message << " = " << a.get_near_star_in().first << endl ;
  cout << "# near star in distance       " << message << " = " << a.get_near_star_in().second << endl ;
  cout << "# near star out degree        " << message << " = " << a.get_near_star_out().first << endl ;
  cout << "# near star out distance      " << message << " = " << a.get_near_star_out().second << endl ;
  cout << "# hub                         " << message << " = " << a.get_hub_autority().first << endl ;
  cout << "# aut                         " << message << " = " << a.get_hub_autority().second << endl ;
  cout << "# classic hub                 " << message << " = " << a.get_classic_hub_autority().first << endl ;
  cout << "# classic aut                 " << message << " = " << a.get_classic_hub_autority().second << endl ;
  cout << "# min connected components    " << message << " = " << a.get_connected_components() << endl  ;
  cout << "# abstraction topologique     " << message << " = " << a.get_abstraction_topologique() << endl ;
  cout << "# abstraction(s) with roles   " << message << " = " << a.get_role() << endl ;
}



bool handle_abstractions(char* argv[], abstraction& a, int& i, string number)
{
	bool found_option = true ;

	if(string(argv[i]) == "-sd" + number)
	{
			a.set_near_star_first(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-sk" + number)
	{
			a.set_near_star_second(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-sd_in" + number)
	{
			a.set_near_star_in_first(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-sk_in" + number)
	{
			a.set_near_star_in_second(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-sd_out" + number)
	{
			a.set_near_star_out_first(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-sk_out" + number)
	{
			a.set_near_star_out_second(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-hub" + number)
	{
		a.set_hub_autority_first(atoi(argv[i+1])) ;
		i = i + 2 ;
	}
	else if(string(argv[i]) == "-aut" + number)
	{
		a.set_hub_autority_second(atoi(argv[i+1])) ;
		i = i + 2 ;
	}
	else if(string(argv[i]) == "-hub_aut" + number)
	{
			a.set_classic_hub_autority_first(atoi(argv[i+1])) ;
			a.set_classic_hub_autority_second(atoi(argv[i+2])) ;
			a.set_role(true) ;
			i = i + 3 ;
	}
	else if(string(argv[i]) == ("-d" + number))
	{
			a.set_degree(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-d" + number + "_in")
	{
			a.set_degree_in(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-d"+ number + "_out")
	{
			a.set_degree_out(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-d" + number + "_simple")
	{
			a.set_degre_simple(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-k" + number)
	{
			a.set_k_dense(atoi(argv[i+1])) ;
			i = i + 2 ;
	}
	else if(string(argv[i]) == "-c" + number)
	{
			 a.set_connected_components(atoi(argv[i+1])) ;
			 i = i + 2 ;
	}
	else if(string(argv[i]) == "-top" + number)
	{
			 a.set_abstraction_topologique(stof(argv[i+1])) ;
			 i = i + 2 ;
	}
	else if(string(argv[i]) == "-t" + number)
	{
			a.set_triangles(true) ;
			i++ ;
	}
	else
		found_option = false ;	

	return found_option ;
}



bool set_a2_abstraction(abstraction& a1, abstraction& a2, bool directed_graph, bool& a2_active)
{
	if (
		(a1.get_degree_in() > 0 || a1.get_degree_out() > 0 || a1.get_degre_simple() > 0 ||
		 a2.get_degree_in() > 0 || a2.get_degree_out() > 0 || a2.get_degre_simple() > 0) 
		 && !directed_graph
	   )
	{
		cerr << "error : you use directed abstractions with a non directed graph" << endl ;
		return false ;
	}


	if (a2.get_k_dense() > 0 || a2.get_triangles() ||
		a2.get_degree() > 0  || a2.get_degree_in() > 0 || a2.get_degree_out() > 0 ||
		a2.get_degre_simple() > 0 ||
		a2.get_near_star().first > 0 || a2.get_near_star_in().first > 0 ||
        a2.get_near_star_out().first > 0 ||
		a2.get_hub_autority().first > 0 ||
		a2.get_classic_hub_autority().first > 0 ||
		a2.get_abstraction_topologique() > 0)
	{
		a2.set_k_dense(max(a2.get_k_dense(), a1.get_k_dense())) ;
		a2.set_degree(max(a2.get_degree(), a1.get_degree())) ;
		a2.set_degree_in(max(a2.get_degree_in(), a1.get_degree_in())) ;
		a2.set_degree_out(max(a2.get_degree_out(), a1.get_degree_out())) ;
		a2.set_degre_simple(max(a2.get_degre_simple(), a1.get_degre_simple())) ;
		a2.set_triangles(max(a2.get_triangles(), a1.get_triangles())) ;
		a2.set_abstraction_topologique(max(a2.get_abstraction_topologique(), a1.get_abstraction_topologique())) ;

		if (a1.get_near_star().first > 0)
		{
		    a2.set_near_star_first(max(a2.get_near_star().first, a1.get_near_star().first)) ;
		    a2.set_near_star_second(min(a2.get_near_star().second, a1.get_near_star().second)) ;
		}

		if (a1.get_near_star_in().first > 0)
		{
		    a2.set_near_star_in_first(max(a2.get_near_star_in().first, a1.get_near_star_in().first)) ;
		    a2.set_near_star_in_second(min(a2.get_near_star_in().second, a1.get_near_star_in().second)) ;
		}

		if (a1.get_near_star_out().first > 0)
		{
		    a2.set_near_star_out_first(max(a2.get_near_star_in().first, a1.get_near_star_out().first)) ;
		    a2.set_near_star_out_second(min(a2.get_near_star_in().second, a1.get_near_star_out().second)) ;
		}

		if (a1.get_hub_autority().first > 0 || a1.get_hub_autority().second >0)
		{
			a2.set_hub_autority_first(max(a2.get_hub_autority().first, a1.get_hub_autority().first)) ;
			a2.set_hub_autority_second(max(a2.get_hub_autority().second, a1.get_hub_autority().second)) ;
		}

		if (a1.get_classic_hub_autority().first > 0 || a1.get_classic_hub_autority().second >0)
		{
				a2.set_classic_hub_autority_first(max(a2.get_classic_hub_autority().first, a1.get_classic_hub_autority().first)) ;
				a2.set_classic_hub_autority_second(max(a2.get_classic_hub_autority().second, a1.get_classic_hub_autority().second)) ;
				a2.set_role(true) ;
		}

		a2.set_connected_components(max(a1.get_connected_components(),
											   a2.get_connected_components())) ;
	}

	a2_active =    (a2.get_role())						||
				(a2.get_triangles() && !a1.get_triangles())  ||
				(a2.get_degree()  > a1.get_degree())         ||
				(a2.get_degree_in()  > a1.get_degree_in())   ||
				(a2.get_degree_out() > a1.get_degree_out())  ||
				(a2.get_abstraction_topologique() > a1.get_abstraction_topologique()) ||
				(a2.get_degre_simple() > a1.get_degre_simple())  ||
				(a2.get_k_dense() > a1.get_k_dense())        ||
			    (
			     (a2.get_near_star().first  > a1.get_near_star().first)  ||
			     (
			      (a2.get_near_star().first  == a1.get_near_star().first) &&
			      (a2.get_near_star().second  < a1.get_near_star().second)
				 )
				) ||
				(
				 (a2.get_classic_hub_autority().first  > a1.get_classic_hub_autority().first)  ||
				 (
				  (a2.get_classic_hub_autority().first  == a1.get_classic_hub_autority().first) &&
				  (a2.get_classic_hub_autority().second  < a1.get_classic_hub_autority().second)
				 )
				) ||
				(
				 (a2.get_hub_autority().first  > a1.get_hub_autority().first)  ||
				 (
				  (a2.get_hub_autority().first  == a1.get_hub_autority().first) &&
				  (a2.get_hub_autority().second  < a1.get_hub_autority().second)
				 )
				) ||
				(
			     (a2.get_near_star_in().first  > a1.get_near_star_in().first)  ||
			     (
			      (a2.get_near_star_in().first  == a1.get_near_star_in().first) &&
			      (a2.get_near_star_in().second  < a1.get_near_star_in().second)
				 )
				) ||
				(
			     (a2.get_near_star_out().first  > a1.get_near_star_out().first)  ||
			     (
			      (a2.get_near_star_out().first  == a1.get_near_star_out().first) &&
			      (a2.get_near_star_out().second  < a1.get_near_star_out().second)
				 )
				) ||
				(a2.get_connected_components() > a1.get_connected_components()) ;

	return true ;
}


