/*
 * SUPPORTS_ATTENDUS
 * read_write_data.cpp 
 *
 *  Created on: 18 mars 2015
 *      Author: Dominique Bouthinon
 *
 */

#include <cstdlib>
#include <algorithm>
#include <vector>
#include <sstream>
#include <fstream>
#include <iostream>
#include <iterator>
#include <set>
#include <string>
#include <tuple>

#include "read_supports_input.hpp"
#include "types_graph.hpp"
#include "utils_divers.hpp"

using namespace std;


void extrait_extension_support(string& line, int debut,
							   string& extension, int& fin, int& support)
{
	extrait_motif(line, debut, extension, fin) ;
	// cerr << "extension = " << extension << endl ;
	string extension2 = extension.substr(1, extension.size()-2) ;
	// cerr << "extension2 = " << extension2 << endl ;
	vector<string> items_extension ;
	split(items_extension, extension2, ",") ;
	// displayVector("items", items_extension) ;
	support = items_extension.size() ;
}


	// idem extrait_extension_support mais en tenant compte de la presence
	// de roles ({role1->{...}, role2->{...},...}
void extrait_extension_support_roles(string& line, int debut,
							   	    int& support)
{
				// recherche la position de l'accolade terminale
	int fin_accolade =  line.size()-1 ;

	int debut_role = debut + 1 ;
	int fin_role ;
	string role  ;
	string role2 ;

	support = 0 ;

				// recherche l'extension liee a chaque role
	do
	{
		// cerr << line << endl ;
		int accolade_ouvrante = line.find('{', debut_role) ;
		extrait_motif(line, accolade_ouvrante, role, fin_role) ;
		// cerr << "role = " << role << endl ;
		string role2 = role.substr(1, role.size()-2) ;
		// cerr << "role2 = " << role2 << endl ;
		vector<string> items_role ;
		split(items_role, role2, ",") ;
		// displayVector("items_roles", items_role) ;
		support = support + items_role.size() ;

		debut_role = fin_role + 2 ;
	}
	while(debut_role < fin_accolade) ;
}

				// recherche le motif et calcul les supports à partir des
				// extensions
void traite_ligne_supports(string& line, string& motif,
		                   string& extension, int& support,
						   string& extension_abstraite,
						   int& support_abstrait)
{
												// isole le motif
	int debut_motif = 0 ;
	int fin_motif ;
	extrait_motif(line, debut_motif, motif, fin_motif) ;
	// cerr << "motif = " << motif << endl ;

												// isole l'extension non abstraite
												// sans les accolades
	int debut_extension  = fin_motif + 3 ;
	int fin_extension ;


	extrait_extension_support(line, debut_extension, extension,
						      fin_extension, support) ;

	// cerr << "extension = " << extension << endl ;

												// isole l'extension non abstraite
												// sans les accolades
	int debut_extension_abstraite  = fin_extension + 3 ;
	int fin_extension_abstraite ;
	extrait_extension_support_roles(line, debut_extension_abstraite,
							        support_abstrait) ;
}


void read_supports_data(const string fileName,
						vector<tuple<string,int,int> >& supports_observes)
{
		ifstream input(fileName , ifstream::in); 		// ouvre fichier

	    if (input)
	    {
			string line ;

			while(getline(input, line))
			{
				//cerr << "line = " << line  << endl ;

				if (line.at(0) != '#')
				{
					string motif ;
					string extension ;
					string extension_abstraite ;
					int support  ;
					int support_abstrait  ;

					traite_ligne_supports(line, motif, extension, support,
										  extension_abstraite, support_abstrait) ;

					// cerr << "motif   = " << motif << endl ;
					// cerr << "extension = " << extension << endl ;
					// cerr << "support = " << support << endl ;
					// cerr << "extension_abstraite = " << extension_abstraite << endl ;
					// cerr << "support_abstrait = " << support_abstrait << endl ;

					supports_observes.push_back(make_tuple(motif, support, support_abstrait)) ;
				}
			}
	    }
	    else
	    {
	    	cout << "the file " << fileName << " cannot be opened." << endl ;
	    }
}

