/*
 * SUPPORTS_ATTENDUS_LOCAUX
 *
 * read_write_data.cpp
 *
 *  Created on: 18 mars 2015
 *      Author: Dominique Bouthinon
 *
 */


#include <cstdlib>
#include <algorithm>
#include <vector>
#include <sstream>
#include <fstream>
#include <iostream>
#include <iterator>
#include <set>
#include <string>
#include <tuple>
#include <math.h>

#include "read_write_data2.hpp"
#include "types_graph.hpp"
#include "utils_divers.hpp"
#include "types_supports_attendus_locaux.hpp"

using namespace std;


void extrait_extension_support(string& line, int debut,
							   string& extension, int& fin, int& support)
{
	extrait_motif(line, debut, extension, fin) ;
	string extension2 = extension.substr(1, extension.size()-2) ;
	vector<string> items_extension ;
	split(items_extension, extension2, ",") ;
	// displayVector("items", items_extension) ;
	support = items_extension.size() ;
}


	// explore line a partir de start,
	// et retourne la derniere accolade
	// qui clot les accolades ouvertes
	// -1 si pas d'accolade fermante
int find_last_brace(string line, int start)
{
	int i = start ;

		// on cherche la premiere accolade ouverte
	while (i < line.size() && line[i] != '{')
	{
		i++ ;
	}

		// pas d'accolade ouvert
	if (i >= line.size())
		return -1 ;

	int nb_accolades_ouvertes = 1 ;


	i++ ;					// pointe caractere suivant l'accolade ouvrante

	while (i < line.size() && nb_accolades_ouvertes > 0)
	{
		// cerr << "i = " << i << " line[i] = " << line[i] << endl ;
		if (line[i] == '}')
			nb_accolades_ouvertes-- ;

		if (line[i] == '{')
			nb_accolades_ouvertes++ ;

		if (nb_accolades_ouvertes > 0)
			i++ ;
	}

	if (nb_accolades_ouvertes == 0)
		return i ;

	return -1 ;
}


// idem extrait_extension_support mais en tenant compte de la presence
// de roles ({role1->{...}, role2->{...},...}
void extrait_extension_support_roles(string& line, int debut, int& fin, int& support)
{
				// recherche la position de l'accolade terminale
	fin =  find_last_brace(line, debut) ;

	int debut_role = debut + 1 ;
	int fin_role ;
	string role  ;
	string role2 ;

	support = 0 ;

				// recherche l'extension liee a chaque role
	do
	{
		// cerr << line << endl ;
		int accolade_ouvrante = line.find('{', debut_role) ;
		extrait_motif(line, accolade_ouvrante, role, fin_role) ;
		// cerr << "role = " << role << endl ;
		string role2 = role.substr(1, role.size()-2) ;
		// cerr << "role2 = " << role2 << endl ;
		vector<string> items_role ;
		split(items_role, role2, ",") ;
		// displayVector("items_roles", items_role) ;
		support = support + items_role.size() ;

		debut_role = fin_role + 2 ;
	}
	while(debut_role < fin) ;
}


	// recherche le motif et calcul les supports à partir des
	// extensions
void traite_ligne_supports_local(
								 string& line,
								 string& motif_c,
							     string& extension_c,
								 int& support_c,
							     string& extension_abstraite_c,
							     int& support_abstrait_c,
								 string& extension_l,
								 int&    support_l,
								 string& extension_abstraite1_l,
								 int& support_abstrait1_l,
								 string& cc_l,
								 int& support_cc_l,
								 string& motif_l
								)
{

	// cerr << "line = " << line << endl ;
									// isole le motif c {...}
	int debut_motif_c = 0 ;
	int fin_motif_c ;
	extrait_motif(line, debut_motif_c, motif_c, fin_motif_c) ;

	// cerr << "motif_c = " << motif_c << endl ;


								// isole l'extension non abstraite de c
								// sans les accolades
	int debut_extension_c  = fin_motif_c + 3 ;
	int fin_extension_c    ;
	extrait_extension_support(line, debut_extension_c, extension_c,
			                  fin_extension_c, support_c) ;

	// cerr << "extension_c = " << extension_c << endl ;

								// isole l'extension abstraite de c
								// sans les accolades
								// (tient compte des roles)
	int debut_extension_abstraite_c  = fin_extension_c + 3 ;
	int fin_extension_abstraite_c  ;

	extrait_extension_support_roles(line, debut_extension_abstraite_c,
									fin_extension_abstraite_c,
								        support_abstrait_c) ;


	// extrait_extension_support(line, debut_extension_abstraite_c, extension_abstraite_c,
	//                           fin_extension_abstraite_c, support_abstrait_c) ;

	// cerr << "support_abstrait_c = " << support_abstrait_c << endl ;

								// isole l'extension non abstraite de l
								// sans les accolades
	int debut_extension_l  = fin_extension_abstraite_c + 3 ;
	int fin_extension_l    ;
	extrait_extension_support(line, debut_extension_l, extension_l,
					                fin_extension_l, support_l) ;

	// cerr << "extension_l = " << extension_l << endl ;

								// isole l'extension abstraite1 de l
								// sans les accolades
								// tient compte des roles
	int debut_extension_abstraite1_l  = fin_extension_l + 3 ;
	int fin_extension_abstraite1_l   ;

	extrait_extension_support_roles(line, debut_extension_abstraite1_l,
									fin_extension_abstraite1_l,
								        support_abstrait1_l) ;

	// cerr << "support_abstrait1_l = " << support_abstrait1_l << endl ;

								// isole l'extension abstraite2 de l
								// dans les accolades
								// tient compte des roles
	int debut_cc_l  = fin_extension_abstraite1_l + 3;
	int fin_cc_l  ;

	extrait_extension_support_roles(line, debut_cc_l,
									fin_cc_l, support_cc_l) ;

	// cerr << "support_cc_l = " << support_cc_l << endl ;

								// isole le motif l {...}
	int debut_motif_l  = fin_cc_l + 3 ;
	int fin_motif_l ;
	extrait_motif(line, debut_motif_l, motif_l, fin_motif_l) ;

	// cerr << "motif_l = " << motif_l << endl ;
}



void read_supports_data_local(
							  const string fileName,
							  vector<Type_tuple_observe>& supports_observes
							  )
{
	ifstream input(fileName , ifstream::in); 		// ouvre fichier

	if (input)
	{
		string line ;

		while(getline(input, line))
		{
		 	if (line.at(0) != '#')
 			{
				string motif_c ;
				string motif_l ;
				string extension_c ;
				int support_c  ;
				string extension_l ;
				int support_l ;
				string extension_abstraite_c ;
				int support_abstrait_c  ;
				string extension_abstraite1_l ;
				int support_abstrait1_l  ;
				string cc_l ;
				int support_cc_l  ;

				// cout << "line = " << line <<  endl ;

										// construct a stream from the string
				traite_ligne_supports_local(line, motif_c,
									  	    extension_c, support_c,
										    extension_abstraite_c, support_abstrait_c,
											extension_l, support_l,
											extension_abstraite1_l,
										   support_abstrait1_l,
											cc_l, support_cc_l, motif_l) ;
				/*
				cerr << "motif_c   = " << motif_c << endl ;
				cerr << "extension_c = " << extension_c << endl ;
				cerr << "support_c = " << support_c << endl ;
				cerr << "extension_abstraite_c = " << extension_abstraite_c << endl ;
				cerr << "support_abstrait_c = " << support_abstrait_c << endl ;

				cerr << "extension_l = " << extension_l << endl ;
				cerr << "support_l = " << support_l << endl ;
				cerr << "extension_abstraite1_l = " << extension_abstraite1_l << endl ;
				cerr << "support_abstrait1_l = " << support_abstrait1_l << endl ;

				cerr << "cc_l = " << cc_l << endl ;
				cerr << "support_cc_l = " << support_cc_l << endl ;
				cerr << "motif_l   = " << motif_l << endl ;
				*/


				supports_observes.push_back(
											make_tuple(
													   motif_c,
													   support_c, support_abstrait_c,
													   support_l, support_abstrait1_l, support_cc_l,
													   motif_l
													 )
								          ) ;
			}
		}
	}
	else
	{
		cout << "the file " << fileName << " cannot be opened." << endl ;
	}
}


