/*
 * COMMON_SUPPORTS_FUNCTIONS.HPP
 *
 * fonctions communes aux programmes 
 * supports_attendus et supports_attendus_locaux
 *  Dominique Bouthinon (LIPN, Université Paris 13)
 */

#include <iostream>

using std::cout;
using std::cerr;
using std::endl;

using namespace std;

#include "common_supports_functions.hpp"


			// retourne aleatoirement un entier entre min (inclus) et max(exclus)
int rand_min_max(int min, int max)
{
	return rand() % (max - min) + min ;
}

			// tire au hasard et sans remise n elements dans vertices
			// les elements tirés sont placés dans drawn_vertices
			// et déplacés vers le haut de vertices
void get_random_vertices(
						 int n,
						 Tvertice_identifier vertices[],
						 int& limite_sup_tirage,
						 Tvertice_identifiers_set& drawn_vertices
						)
{
	for (int i = 0 ; i < n ; i++)
	{
								// k est l'indice de l'élément a tirer dans vertices
								// (0<= k < limite_sup_tirage)
		int k = rand_min_max(0, limite_sup_tirage) ;

		// cerr << "k = " << k << endl ;
												// on récupère le noeud d'indice k
		Tvertice_identifier ident = vertices[k] ;

		drawn_vertices.insert(ident) ;			// on l'insère dans draw_vertices
												// on permute le noeud tiré avec
												// le noeud de rang limite_sup_tirage-1
		vertices[k] = vertices[limite_sup_tirage-1] ;
		vertices[limite_sup_tirage-1] = ident ;

		limite_sup_tirage-- ;
	}
}


// tire au hasard SANS LES RETIRER n elements parmi les m elemtns de vertices
// les elements tirés sont placés dans drawn_vertices
void get_random_vertices2(
			 int n,
			 Tvertice_identifier vertices[],
			 int m,
			 Tvertice_identifiers_set& drawn_vertices
			)
{
	for (int i = 0 ; i < n ; i++)
	{
							// k est l'indice de l'élément a tirer dans vertices
							// (0<= k < m)
		int k = rand_min_max(0, m) ;

		// cerr << "k = " << k << endl ;
											// on récupère le noeud d'indice k
		Tvertice_identifier ident = vertices[k] ;

		drawn_vertices.insert(ident) ;		// on l'insère dans draw_vertices
											// on permute le noeud tiré avec
											// le noeud de rang limite_sup_tirage-1
		vertices[k] = vertices[m-1] ;
		vertices[m-1] = ident ;

		m-- ;
	}
}



void displayTab(Tvertice_identifier t[], int n)
{
	for (int i = 0 ; i < n ; i++)
	{
		cout << i << ":" << t[i] << ", " ;
	}
	cout << endl ;
}

